package jdk.management.resource.internal.inst;

import jdk.internal.instrumentation.InstrumentationMethod;
import jdk.management.resource.ResourceRequest;
import jdk.management.resource.ResourceRequestDeniedException;
import java.io.IOException;
import jdk.management.resource.internal.ApproverGroup;
import jdk.management.resource.internal.ResourceIdImpl;
import java.io.FileDescriptor;
import java.net.ProtocolFamily;
import jdk.internal.instrumentation.InstrumentationTarget;
import jdk.Exported;

@Exported(false)
@InstrumentationTarget("sun.nio.ch.Net")
public class NetRMHooks
{
    public NetRMHooks() {
    }
    
    @InstrumentationMethod
    static FileDescriptor socket(ProtocolFamily protocolFamily, boolean b) throws IOException {
        FileDescriptor socket = socket(protocolFamily, b);
        ResourceIdImpl of = ResourceIdImpl.of(socket);
        ResourceRequest approver = ApproverGroup.FILEDESCRIPTOR_OPEN_GROUP.getApprover(socket);
        long request = 0L;
        long n = 0L;
        try {
            try {
                request = approver.request(1L, of);
                if (request < 1L) {
                    throw new IOException("Resource limited: too many open file descriptors");
                }
            }
            catch (ResourceRequestDeniedException cause) {
                throw new IOException("Resource limited: too many open file descriptors", cause);
            }
            n = 1L;
        }
        finally {
            approver.request(-(request - n), of);
        }
        return socket;
    }
    
    @InstrumentationMethod
    static FileDescriptor serverSocket(boolean b) {
        FileDescriptor serverSocket = serverSocket(b);
        ResourceIdImpl of = ResourceIdImpl.of(serverSocket);
        ResourceRequest approver = ApproverGroup.FILEDESCRIPTOR_OPEN_GROUP.getApprover(serverSocket);
        long request = 0L;
        long n = 0L;
        try {
            request = approver.request(1L, of);
            if (request < 1L) {
                throw new ResourceRequestDeniedException("Resource limited: too many open file descriptors");
            }
            n = 1L;
        }
        finally {
            approver.request(-(request - n), of);
        }
        return serverSocket;
    }
}
